class CMainWindow : public CWindow
{
public:
	CMainWindow() : CWindow() { ; }
	void Create(bool alwaysOnTop);
	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnPaint(WPARAM wParam, LPARAM lParam);
	// void OnPaint(HDC hdc, RECT crt);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	virtual LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
	virtual LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);
	virtual LRESULT OnMouseMove(WPARAM wParam, LPARAM lParam);
	virtual LRESULT OnLButtonUp(WPARAM wParam, LPARAM lParam);
};

class CTrayWindow : public CWindow
{
public:
	CTrayWindow() : CWindow() { ; }
	void Create() {
		win_hWnd = CreateWindow(TEXT("CWindow"), NULL, WS_CHILD | WS_VISIBLE,
			0, 0, 0, 0, mainWindow.win_hWnd, (HMENU)2, g_hInst, this);
	}

	//  ä⸸ Ѵ.
	void OnPaint(HDC hdc, RECT crt) {
		FillRect(hdc, &crt, GetSysColorBrush(COLOR_BTNFACE));
	}
};

// Ϲ Լ
void Relayout();
void UpdateTrayThick(int widgetThick);
void ArrangeTrayTidget(int widgetThick);
int FindSplitVirt(int cy);
int FindSplitHorz(int cx);
bool IsInCaption(int cx, int cy);
INT_PTR CALLBACK SelWidgetDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK SelTidgetDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);

