LRESULT CALLBACK LCDTest_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK SizeMeter_WndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);

// Ƽ Ŭ. Ŭ   
class CTidget : public CDget
{
public:
	CTidget(LPCTSTR name, LPCTSTR id) : CDget(name, id) { ; }

	// Ŭ   . ϵ OnClick ϸ ȴ. 콺   Ϸ
	//  ڵ鷯 ϵ Ŭ  θ ޼带  ȣؾ Ѵ.
	LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam)	{
		SetCapture(win_hWnd);
		return 0;
	}

	LRESULT OnLButtonUp(WPARAM wParam, LPARAM lParam) {
		if (GetCapture() != win_hWnd) return 0;
		ReleaseCapture();

		POINT pt = { (int)(short)LOWORD(lParam) , (int)(short)HIWORD(lParam) };
		RECT crt;
		GetClientRect(win_hWnd, &crt);
		if (PtInRect(&crt, pt) == false) return 0;

		OnClick();
		return 0;
	}

	virtual void OnClick() { ; }
};

class CLCDTest : public CTidget
{
public:
	HBITMAP icon;
	CLCDTest(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		icon = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_LCD_NOR));

		// todo : LCD â CWindow ļ   . SizeMeter 
		WNDCLASS WndClass;
		WndClass.cbClsExtra = 0;
		WndClass.cbWndExtra = 0;
		WndClass.hbrBackground = NULL;
		WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		WndClass.hInstance = g_hInst;
		WndClass.lpfnWndProc = LCDTest_WndProc;
		WndClass.lpszClassName = L"LCDTest";
		WndClass.lpszMenuName = NULL;
		WndClass.style = CS_HREDRAW | CS_VREDRAW;
		RegisterClass(&WndClass);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		DeleteObject(icon);
		return 0;
	}

	void OnDraw(HDC hdc, RECT crt) {
		DrawBitmap(hdc, 0, 0, icon);
	}

	void OnClick() {
		//   輱 . 콺 Ŀ . IME  
		//  ī     . Ƽ      ִ. 
		CreateWindowEx(WS_EX_TOPMOST, L"LCDTest", L"LCDTest", WS_POPUP | WS_VISIBLE,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			win_hWnd, (HMENU)NULL, g_hInst, NULL);
	}
};

class CSizeMeter : public CTidget
{
public:
	HBITMAP icon;
	CSizeMeter(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam) {
		icon = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_SIZE_NOR));

		WNDCLASS WndClass;
		WndClass.cbClsExtra = 0;
		WndClass.cbWndExtra = 0;
		WndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
		WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		WndClass.hInstance = g_hInst;
		WndClass.lpfnWndProc = SizeMeter_WndProc;
		WndClass.lpszClassName = L"SizeMeter";
		WndClass.lpszMenuName = NULL;
		WndClass.style = CS_HREDRAW | CS_VREDRAW;
		RegisterClass(&WndClass);
		return 0;
	}

	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) {
		DeleteObject(icon);
		return 0;
	}

	void OnDraw(HDC hdc, RECT crt) {
		DrawBitmap(hdc, 0, 0, icon);
	}

	void OnClick() {
		CreateWindow(L"SizeMeter", L"SizeMeter", WS_OVERLAPPEDWINDOW | WS_VISIBLE,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			NULL, (HMENU)NULL, g_hInst, NULL);
	}
};

class CMoveCursor : public CTidget
{
public:
	HBITMAP bitOn, bitOff;
	bool bCursorMove;			// Ŀ  ̵ 
	int TimerInterval;			// Ÿ̸ ֱ
	int CursorInterval;			// Ŀ  ̵ ֱ(ʴ)
	int CursorKeepSec;			// Ŀ  ʰ  ڸ ־ ð
	int RejectCount;			// Ŀ ̵ ȸ(ũ ̹  ȸ)
	POINT OldCursorPt;			//  Ŀ ġ
	CMoveCursor(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	void OnClick();
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
};

// ϴ Ctrl+Shift+C Ű ɸ  
// todo : ڵ ȯ ɼ, Ű , ȯ Ƚ  ֱ
class CTextClip : public CTidget
{
public:
	HBITMAP bitOn, bitOff;
	bool bClipToText;
	int clipCount;
	CTextClip(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { ; }

	LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	void OnClick();
	void ClipboardTextOnly();
};

class COneImageViewer;
class COneImage : public CTidget
{
public:
	TCHAR imagePath[MAX_PATH];
	Image *nowImage;
	HBITMAP hOneImage;
	CImageViewer *pViewer;

	COneImage(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { 
		lstrcpy(imagePath, L"");
		nowImage = NULL;
		pViewer = NULL;
	}

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	void OnClick();
	LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam);
	LRESULT OnUser1(WPARAM wParam, LPARAM lParam);
};

class CTetris : public CTidget
{
public:
	HBITMAP hBitmap;

	CTetris(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	void OnClick();
};

class CTetrisGame : public CWindow
{
public:
	enum { EMPTY, BRICK, WALL = 7/*sizeof(Shape) / sizeof(Shape[0]) + 1*/ };
	int ts;
	int bw;
	int bh;
	int board[1000][1000];
	int nx, ny;
	int brick, rot;
	int nbrick;
	int score;
	int bricknum;
	int Interval;
	enum Status { GAMEOVER, RUNNING, PAUSE };
	Status GameStatus;
	HBRUSH arBrush[8];

	CTetrisGame() : CWindow() {
		ts = 24;
		bw = 10;
		bh = 20;
		score = 0;
		bricknum = 0;
		memset(board, 0, sizeof(board));
	}

	void Create();
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnTimer(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);

	void MakeNewBrick();
	int GetAround(int x, int y, int b, int r);
	BOOL MoveDown();
	void TestFull();
	void PrintTile(HDC hdc, int x, int y, int c);
	void AdjustMainWindow();
};

class CColorTable : public CTidget
{
public:
	HBITMAP hBitmap;

	CColorTable(LPCTSTR name, LPCTSTR id) : CTidget(name, id) { ; }

	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	void OnClick();
};

class CColorTableApp : public CWindow
{
public:
	HWND hList, hBtnCopy[4];
	enum {CT_LIST, CT_COPY1, CT_COPY2, CT_COPY3, CT_COPY4 };
	struct sOneColor
	{
		TCHAR name[32];
		COLORREF color;
	};
	sOneColor arColor[300];
	int colorCount;
	bool namedColor;
	int tile_width;
	int tile_height;
	int perLine;
	const int leftMargin = 150;
	int selIdx, prevSel;

	CColorTableApp() : CWindow() {
	}

	void Create();
	LRESULT OnCreate(WPARAM wParam, LPARAM lParam);
	LRESULT OnDestroy(WPARAM wParam, LPARAM lParam);
	LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	void OnDraw(HDC hdc, RECT crt);
	LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam);

	void PrepareColor(int colorType);
	static int colorNameCompare(const void* a, const void* b);
	void CalcTileSize();
	void ChangeSelColor(int idx);
};

