class CWindow;
class CRegisterHelper
{
public:
	CRegisterHelper();
	~CRegisterHelper();

	struct _arObj
	{
		CWindow* pObj;
		HWND hWnd;
	} *arObj;
	int arSize;
	int nReg;

	CWindow* FindObject(HWND hWnd);
	void AddObject(HWND hWnd, CWindow* pObj);
	void RemoveObject(HWND hWnd);
};

// Ϲ  Ŭ. MFC CWnd شϵ   ߴ. 
class CWindow
{
public:
	HWND win_hWnd;
	// ϴ Ÿ . ̸ x, y      򰥷 win_  
	int win_x;						//  X ǥ
	int win_y;						//  Y ǥ
	int win_w;						//  ʺ
	int win_h;						//  
	HBRUSH win_backBrush;			//  귯.  backColorκ ̸  д.
	HBITMAP win_dblBuffer;			// ۸ Ʈ

	CWindow() { 
		win_backBrush = NULL;
		win_dblBuffer = NULL;
	}
	~CWindow() {
		if (win_backBrush != NULL) DeleteObject(win_backBrush);
		if (win_dblBuffer != NULL) DeleteObject(win_dblBuffer);
		if (_RegisterHelper.arObj) _RegisterHelper.RemoveObject(win_hWnd);
	}

	//  ϵ  ϵ  μ this Ͽ üʿ Ѵ.
	//  ¿ ٸ (Ȯ Ÿ, ǥ ) Create Ͽ  Ѵ. 
	virtual void Create(HWND hParent, int child_id = 0, LPCTSTR title = L"", 
		DWORD style = WS_CHILD | WS_VISIBLE) {
		CreateWindow(TEXT("CWindow"), title, style,
			0, 0, 0, 0, hParent, (HMENU)(ULONG_PTR)child_id, g_hInst, this);
	}

	virtual void LoadSetting() {}
	virtual void SaveSetting() {}
	virtual LRESULT OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam);
	virtual LRESULT OnCreate(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnDestroy(WPARAM wParam, LPARAM lParam) { return 0; }
	// OnPaint ϴ Ʈ   ۸ غ ؼ  Լ ȣѴ.     Ѵ.
	virtual LRESULT OnPaint(WPARAM wParam, LPARAM lParam);
	virtual void OnDraw(HDC hdc, RECT crt) { }
	virtual LRESULT OnTimer(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnSize(WPARAM wParam, LPARAM lParam);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnContextMenu(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnLButtonDown(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnMouseMove(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnLButtonUp(WPARAM wParam, LPARAM lParam) { return 0; } 
	virtual LRESULT OnLButtonDblClk(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnMouseWheel(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnUser1(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnUser2(WPARAM wParam, LPARAM lParam) { return 0; }
	virtual LRESULT OnDropFiles(WPARAM wParam, LPARAM lParam) { return 0; }

	static LRESULT CALLBACK CWindowProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
};

// , Ƽ  
class CDget : public CWindow
{
public:
	TCHAR dget_name[32];				// ڿ   . UI 
	TCHAR dget_id[32];					//   Ī. INI  Ǹ 

	// ̸ id ޾Ƽ ʱȭϴ . ּ    ־ Ѵ. 
	CDget(LPCTSTR name, LPCTSTR id) {
		lstrcpy(this->dget_name, name);
		lstrcpy(this->dget_id, id);
	}
};


